#include <iostream>

using namespace std;

int main(){
int N, K, M;
cin >> N >> K;
int Pneg[N];
int Ppoz[N];
int P0 = 0;
int Q = 0;
for(int i = 0 ; i < N ; i++)
{
Ppoz[i] = 0;
}
for(int i = 0 ; i < N ; i++)
{
Pneg[i] = 0;
}
for(int i = 0 ; i < N ; i++)
{
cin >> M;
if(M > 0)
{
Ppoz[M-1]++;
if(Ppoz[M-1]==K) Q++;
}
else if(M < 0)
{
Pneg[-M-1]++;
if(Pneg[-M-1]==K) Q++;
}
else
{
P0++;
if(P0==K) Q++;
}
}
cout << Q << endl;
for(int i = 0 ; i < N ; i++)
{
if(Ppoz[i]>=K) cout<<i+1<<" ";
}
for(int i = 0 ; i < N ; i++)
{
if(Pneg[i]>=K) cout<<-i-1<<" ";
}
if(P0>=K) cout<<0<<" ";
return 0;
}